#!/usr/bin/python
#
# (c) Max Kresch, licensed under BSD, 2008.
#     See LICENSE for further details. 


import numpy     as n
import mat2vec   as m2v
import rrEchelon as rre
import cPickle   as cp

nar = n.add.reduce
Tol = 1e-10

Syms = cp.load(open("S.pkl",'r'))  # This was created with "getSyms.py"

V = []
V.append( n.matrix([[1],[1],[0]]) )
V.append( n.matrix([[2],[0],[0]]) )
V.append( n.matrix([[2],[1],[1]]) )
V.append( n.matrix([[2],[2],[0]]) )
V.append( n.matrix([[3],[1],[0]]) )
V.append( n.matrix([[2],[2],[2]]) )
V.append( n.matrix([[3],[2],[1]]) )
V.append( n.matrix([[4],[0],[0]]) )


def notAllZero(r):
  res = False
  for i in r:
    if i != 0:
      res = True
  return res


for v in V:
  S = []     
  for i in Syms:
    if nar(nar( n.array(i*v - v)**2 )) < Tol:
      S.append(i)

  A = []
  for s in S:
    A.append( m2v.doit(s) )

  A = n.array(A)
  A.shape = ( -1,len(A[0]) )
  constraints = rre.doit(A)
  print ''
  print '-----------------------------------'
  print ' xx  xy  xz  yx  yy  yz  zx  zy  zz'
  print '-----------------------------------'
  print ''
  for c in constraints:
    if notAllZero(c):
      print c
