#!/usr/bin/python
#
# (c) Max Kresch, licensed under BSD, 2008.
#     See LICENSE for further details. 


import numpy     as n
import mat2vec   as m2v
import rrEchelon as rre

def notAllZero(r):
  res = False
  for i in r:
    if i != 0:
      res = True
  return res

S0 = n.array( [[ 1.0, 0.0, 0.0 ],
               [ 0.0, 0.0, 1.0 ],
               [ 0.0, 1.0, 0.0 ]] )

S1 = n.array( [[ 1.0, 0.0, 0.0 ],
               [ 0.0, 1.0, 0.0 ],
               [ 0.0, 0.0,-1.0 ]] )

S2 = n.array( [[ 1.0, 0.0, 0.0 ],
               [ 0.0,-1.0, 0.0 ],
               [ 0.0, 0.0, 1.0 ]] )

S3 = n.array( [[ 1.0, 0.0, 0.0 ],
               [ 0.0, 1.0, 0.0 ],
               [ 0.0, 0.0, 1.0 ]] )

S = [S0,S1,S2,S3]

A = []
for s in S:
  A.append( m2v.doit(s) )


A = n.array(A)
A.shape = ( -1,len(A[0]) )

# print A
# print ''
constraints = rre.doit(A)

print ' xx  xy  xz  yx  yy  yz  zx  zy  zz'
for c in constraints:
  if notAllZero(c):
    print c
