#!/usr/bin/python
#
# (c) Max Kresch, licensed under BSD, 2008.
#     See LICENSE for further details. 


def doit(S):
  M = S.copy()
  eliminate(M)
  for r in range(len(M)-1,0,-1):
    c = findCnonZero(M[r])
    if c :
      for i in range(r):
        add(M,i,-1*M[i,c],r)
  return M

def findCnonZero(M_r):
  c = 0
  while c < len(M_r) and M_r[c] == 0:
    c += 1
  if c == len(M_r):
    c = False
  return c

def eliminate(M):
  r = 0
  c = 0
  while r < len(M) and c < len(M[0]):
    if nonZeroToTop(M[r:,c:]):
      M[r:,c:] = cleanCol0(M[r:,c:])
      r += 1
      c += 1
    else:
      c += 1
  return M

def nonZeroToTop(M):
    count = 0
    maxCount = len(M)
    while M[0,0] == 0 and count < maxCount:
      count += 1
      tmp = M[0].copy()
      M[0:-1] = M[1:].copy()
      M[-1] = tmp
    return ( M[0,0] != 0 )

def cleanCol0(M):
  if M[0,0] != 0:
    scaleTo1(M,0)
    for r in range(1,len(M)):
      if M[r,0] != 0:
        scaleTo1(M,r)
        add(M,r,-1.0,0)
  return M

def scaleTo1(M,r):
  if M[r,0] != 0:
    scale(M,r, 1.0/M[r,0] )
  return 

def scale(M,r,s):
  M[r] *= s
  return

def add(M,r1,s,r2):
  M[r1] += s*M[r2]
  return
